diff -ruN qmail-1.03-orig/control.c qmail-1.03-ldap-20060201-orig/control.c
--- qmail-1.03-orig/control.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/control.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "readwrite.h"
 #include "open.h"
 #include "getln.h"
@@ -7,6 +8,7 @@
 #include "control.h"
 #include "alloc.h"
 #include "scan.h"
+#include "limit.h"
 
 static char inbuf[64];
 static stralloc line = {0};
@@ -27,7 +29,7 @@
     }
 }
 
-int control_init()
+int control_init(void)
 {
  int r;
  r = control_readline(&me,"control/me");
@@ -37,9 +39,9 @@
 
 int control_rldef(sa,fn,flagme,def)
 stralloc *sa;
-char *fn;
+const char *fn;
 int flagme;
-char *def;
+const char *def;
 {
  int r;
  r = control_readline(sa,fn);
@@ -51,7 +53,7 @@
 
 int control_readline(sa,fn)
 stralloc *sa;
-char *fn;
+const char *fn;
 {
  substdio ss;
  int fd;
@@ -60,7 +62,7 @@
  fd = open_read(fn);
  if (fd == -1) { if (errno == error_noent) return 0; return -1; }
  
- substdio_fdbuf(&ss,read,fd,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ss,subread,fd,inbuf,sizeof(inbuf));
 
  if (getln(&ss,sa,&match,'\n') == -1) { close(fd); return -1; }
 
@@ -71,7 +73,7 @@
 
 int control_readint(i,fn)
 int *i;
-char *fn;
+const char *fn;
 {
  unsigned long u;
  switch(control_readline(&line,fn))
@@ -81,13 +83,33 @@
   }
  if (!stralloc_0(&line)) return -1;
  if (!scan_ulong(line.s,&u)) return 0;
+ if (u > INT_MAX) {
+   errno = error_range;
+   return -1;
+ }
  *i = u;
  return 1;
 }
 
+int control_readulong(ul,fn)
+unsigned long *ul;
+const char *fn;
+{
+ unsigned long u;
+ switch(control_readline(&line,fn))
+  {
+   case 0: return 0;
+   case -1: return -1;
+  }
+ if (!stralloc_0(&line)) return -1;
+ if (!scan_ulong(line.s,&u)) return 0;
+ *ul = u;
+ return 1;
+}
+
 int control_readfile(sa,fn,flagme)
 stralloc *sa;
-char *fn;
+const char *fn;
 int flagme;
 {
  substdio ss;
@@ -112,7 +134,7 @@
    return -1;
   }
 
- substdio_fdbuf(&ss,read,fd,inbuf,sizeof(inbuf));
+ substdio_fdbuf(&ss,subread,fd,inbuf,sizeof(inbuf));
 
  for (;;)
   {
@@ -128,3 +150,33 @@
  close(fd);
  return -1;
 }
+
+int control_readrawfile(sa,fn)
+stralloc *sa;
+const char *fn;
+{
+ substdio ss;
+ int fd;
+ int match;
+
+ if (!stralloc_copys(sa,"")) return -1;
+
+ fd = open_read(fn);
+ if (fd == -1) 
+  {
+   if (errno == error_noent) return 0;
+   return -1;
+  }
+
+ substdio_fdbuf(&ss,subread,fd,inbuf,sizeof(inbuf));
+
+ for (;;)
+  {
+   if (getln(&ss,&line,&match,'\n') == -1) break;
+   if (!match && !line.len) { close(fd); return 1; }
+   if (!stralloc_cat(sa,&line)) break;
+   if (!match) { close(fd); return 1; }
+  }
+ close(fd);
+ return -1;
+}
diff -ruN qmail-1.03-orig/control.h qmail-1.03-ldap-20060201-orig/control.h
--- qmail-1.03-orig/control.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/control.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,10 +1,14 @@
 #ifndef CONTROL_H
 #define CONTROL_H
 
-extern int control_init();
-extern int control_readline();
-extern int control_rldef();
-extern int control_readint();
-extern int control_readfile();
+#include "stralloc.h"
+
+extern int control_init(void);
+extern int control_readline(stralloc *, const char *);
+extern int control_rldef(stralloc *, const char *, int, const char *);
+extern int control_readint(int *, const char *);
+extern int control_readulong(unsigned long *, const char *);
+extern int control_readfile(stralloc *, const char *, int);
+extern int control_readrawfile(stralloc *, const char *);
 
 #endif
diff -ruN qmail-1.03-orig/date822fmt.c qmail-1.03-ldap-20060201-orig/date822fmt.c
--- qmail-1.03-orig/date822fmt.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/date822fmt.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,7 +2,7 @@
 #include "fmt.h"
 #include "date822fmt.h"
 
-static char *montab[12] = {
+static const char *montab[12] = {
 "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
 };
 
diff -ruN qmail-1.03-orig/date822fmt.h qmail-1.03-ldap-20060201-orig/date822fmt.h
--- qmail-1.03-orig/date822fmt.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/date822fmt.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,9 @@
 #ifndef DATE822FMT_H
 #define DATE822FMT_H
 
-extern unsigned int date822fmt();
+#include "datetime.h"
+
+extern unsigned int date822fmt(char *, struct datetime *);
 #define DATE822FMT 60
 
 #endif
diff -ruN qmail-1.03-orig/datetime.h qmail-1.03-ldap-20060201-orig/datetime.h
--- qmail-1.03-orig/datetime.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/datetime.h	2006-02-25 11:00:55.000000000 +0100
@@ -14,7 +14,7 @@
 
 typedef long datetime_sec;
 
-extern void datetime_tai();
-extern datetime_sec datetime_untai();
+extern void datetime_tai(struct datetime *, datetime_sec);
+extern datetime_sec datetime_untai(struct datetime *);
 
 #endif
diff -ruN qmail-1.03-orig/digest.c qmail-1.03-ldap-20060201-orig/digest.c
--- qmail-1.03-orig/digest.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,231 @@
+/*
+ * Copyright (c) 1998-2004 Andre Oppermann, Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/types.h>
+#include <fcntl.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <unistd.h>
+
+#include "base64.h"
+#include "case.h"
+#include "error.h"
+#include "passwd.h"
+#include "qldap-errno.h"
+#include "readwrite.h"
+#include "sgetopt.h"
+#include "stralloc.h"
+
+
+#define RANDDEV "/dev/urandom"
+
+const char *mode[] = {
+	"{CRYPT}",
+       	"{MD4}",
+       	"{MD5}",
+       	"{NS-MTA-MD5}",
+       	"{SMD5}",
+       	"{SHA}",
+       	"{SSHA}",
+       	"{RMD160}",
+       	0
+};
+
+const char *mode2[] = {
+	"crypt",
+       	"md4",
+       	"md5",
+       	"ns-mta-md5",
+       	"smd5",
+       	"sha",
+       	"ssha",
+       	"rmd160",
+       	0
+};
+
+stralloc pw = {0};
+stralloc salt = {0};
+
+void
+usage(void)
+{
+	fprintf(stderr,
+	    "usage:\tdigest [ -c ] [ -b | -5 | -C | -f cryptformat ] [ -s base64Salt ]\n\t[ -S hexSalt ] [ -t type ] passwd\n"
+	    "\tdigest -v password hashedPassword\n");
+	exit(1);
+}
+
+void
+getsalt(stralloc *b, int blen)
+{
+	char buf[64];
+	int l, fd;
+	
+	fd = open(RANDDEV, O_RDONLY);
+	if (fd == -1) {
+		fprintf(stderr, "digest: open %s failed: %s.\n",
+		    RANDDEV, error_str(errno));
+		exit(1);
+	}
+	l = read(fd, buf, sizeof(buf));
+	if (l == -1) {
+		fprintf(stderr, "digest: read failed: %s.\n",
+		    error_str(errno));
+		exit(1);
+	}
+	if (l < blen) {
+		fprintf(stderr, "digest: not enough random data read.\n");
+		exit(1);
+	}
+	if (!stralloc_copyb(b, buf, blen)) {
+		fprintf(stderr, "digest: stralloc_copyb failed: %s.\n",
+		    error_str(errno));
+		exit(1);
+	}
+}
+
+int
+main(int argc, char *argv[])
+{
+	int	i, opt, m, type = -1;
+	char	*clear, *encrypted;
+	const char *cformat;
+	
+	clear = (char *)0;
+	encrypted = (char *)0;
+	m = 0;
+	cformat = "XX";
+	while ((opt = getopt(argc, argv, "5bcf:s:S:t:v")) != opteof)
+		switch (opt) {
+		case '5':
+			/* md5 format */
+			cformat = "$1$XXXXXXXX$";
+			break;
+		case 'b':
+			/* blowfish format */
+			cformat = "$2a$07$XXXXXXXXXXXXXXXXXXXXXXXX";
+			break;
+		case 'C':
+			/* good (acctually bad) old crypt */
+			cformat = "XX";
+			break;
+		case 'c':
+			m = 0;
+			break;
+		case 'f':
+			cformat = optarg;
+			break;
+		case 's':
+			if (b64_ptons(optarg, &salt) == -1) {
+				fprintf(stderr, "digest: bad base64 string.\n");
+				usage();
+			}
+			break;
+		case 'S':
+			if (hex_ptons(optarg, &salt) == -1) {
+				fprintf(stderr, "digest: bad hex string.\n");
+				usage();
+			}
+			break;
+		case 't':
+			for (i = 0; mode2[i] != 0; i++)
+				if (!case_diffs(mode2[i], optarg))
+					break;
+			if (mode2[i]) {
+				type = i;
+				break;
+			}
+			fprintf(stderr,
+			    "digest: bad digest type, use one of:\n");
+			for (i = 0; mode2[i] != 0; i++)
+				fprintf(stderr, "\t%s\n", mode2[i]);
+			exit(1);
+		case 'v':
+			m = 1;
+			break;
+		default:
+			
+			usage();
+		}
+
+	argc -= optind;
+	argv += optind;
+	if (m == 0) {
+		if (argc != 1) usage();
+		clear = argv[0];
+		if (salt.s == 0)
+			getsalt(&salt, 18); /* actually 128bit salt but add
+					     * a bit for base64 errors */
+		feed_salt(salt.s, salt.len);
+		feed_crypt(cformat);
+		if (type != -1) {
+			if (make_passwd(mode[type], clear, &pw) == OK) {
+				stralloc_0(&pw);
+				printf("%s%s\n", mode[type], pw.s);
+			} else
+				printf("%s failed.\n", mode2[type]);
+		} else 
+			for (i = 0; mode[i] != 0; i++) {
+				if (make_passwd(mode[i], clear, &pw) == OK) {
+					stralloc_0(&pw);
+					printf("%s%s\n", mode[i], pw.s);
+				} else
+					printf("%s failed.\n", mode2[i]);
+			}
+	} else {
+		if (argc != 2) usage();
+		clear = argv[0];
+		encrypted = argv[1];
+		switch(cmp_passwd(clear, encrypted)) {
+		case OK:
+			printf("passwords are equal.\n");
+			break;
+		case BADPASS:
+			printf("passwords are NOT equal.\n");
+			break;
+		case ERRNO:
+			printf("digest: cmp_passwd: %s.\n", error_str(errno));
+			exit(1);
+		case ILLVAL:
+			printf("digest: cmp_password: "
+			    "illegal hashed password.\n");
+			exit(1);
+		default:
+			printf("digest: cmp_password: failed.");
+			exit(1);
+		}
+	}
+	
+	exit(0);
+}
+
diff -ruN qmail-1.03-orig/digest_md4.c qmail-1.03-ldap-20060201-orig/digest_md4.c
--- qmail-1.03-orig/digest_md4.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_md4.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,290 @@
+/* digest_md4.c for QLDAP modified to use djb stuff    */
+/* contains MD4 algorithm stolen directly from OpenBSD */
+
+/*        */
+/*  MD4   */
+/*        */
+
+/* Copyright (C) 1990-2, RSA Data Security, Inc. All rights reserved.
+
+   License to copy and use this software is granted provided that it
+   is identified as the "RSA Data Security, Inc. MD4 Message-Digest
+   Algorithm" in all material mentioning or referencing this software
+   or this function.
+
+   License is also granted to make and use derivative works provided
+   that such works are identified as "derived from the RSA Data
+   Security, Inc. MD4 Message-Digest Algorithm" in all material
+   mentioning or referencing the derived work.
+
+   RSA Data Security, Inc. makes no representations concerning either
+   the merchantability of this software or the suitability of this
+   software for any particular purpose. It is provided "as is"
+   without express or implied warranty of any kind.
+
+   These notices must be retained in any copies of any part of this
+   documentation and/or software.
+ */
+
+#include <sys/types.h>
+#include "uint32.h"
+#include "byte.h"
+#include "digest_md4.h"
+
+/* POINTER defines a generic pointer type */
+typedef unsigned char *POINTER;
+
+/* Constants for MD4Transform routine.
+ */
+#define S11 3
+#define S12 7
+#define S13 11
+#define S14 19
+#define S21 3
+#define S22 5
+#define S23 9
+#define S24 13
+#define S31 3
+#define S32 9
+#define S33 11
+#define S34 15
+
+static void MD4Transform(uint32 [4], const unsigned char [64]);
+
+#ifdef __LITTLE_ENDIAN__
+#define Encode byte_copy
+#define Decode byte_copy
+#else  /* __BIG_ENDIAN__ */
+static void Encode(void *, size_t, const void *);
+static void Decode(void *, size_t, const void *);
+#endif /* __LITTLE_ENDIAN__ */
+
+static unsigned char PADDING[64] = {
+  0x80, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
+  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+};
+
+/* F, G and H are basic MD4 functions.
+ */
+#define F(x, y, z) (((x) & (y)) | ((~x) & (z)))
+#define G(x, y, z) (((x) & (y)) | ((x) & (z)) | ((y) & (z)))
+#define H(x, y, z) ((x) ^ (y) ^ (z))
+
+/* ROTATE_LEFT rotates x left n bits.
+ */
+#define ROTATE_LEFT(x, n) (((x) << (n)) | ((x) >> (32-(n))))
+
+/* FF, GG and HH are transformations for rounds 1, 2 and 3 */
+/* Rotation is separate from addition to prevent recomputation */
+#define FF(a, b, c, d, x, s) { \
+    (a) += F ((b), (c), (d)) + (x); \
+    (a) = ROTATE_LEFT ((a), (s)); \
+  }
+#define GG(a, b, c, d, x, s) { \
+    (a) += G ((b), (c), (d)) + (x) + (uint32)0x5a827999; \
+    (a) = ROTATE_LEFT ((a), (s)); \
+  }
+#define HH(a, b, c, d, x, s) { \
+    (a) += H ((b), (c), (d)) + (x) + (uint32)0x6ed9eba1; \
+    (a) = ROTATE_LEFT ((a), (s)); \
+  }
+
+#ifdef __BIG_ENDIAN__
+/* Encodes input (uint32) into output (unsigned char). Assumes len is
+     a multiple of 4.
+ */
+static void
+Encode(void *out, size_t len, const void *in)
+{
+  const uint32 *input = in;
+  unsigned char *output = out;
+  size_t i, j;
+
+  for (i = 0, j = 0; j < len; i++, j += 4) {
+    output[j] = (unsigned char)(input[i] & 0xff);
+    output[j+1] = (unsigned char)((input[i] >> 8) & 0xff);
+    output[j+2] = (unsigned char)((input[i] >> 16) & 0xff);
+    output[j+3] = (unsigned char)((input[i] >> 24) & 0xff);
+  }
+}
+
+/* Decodes input (unsigned char) into output (uint32). Assumes len is
+     a multiple of 4.
+ */
+static void
+Decode(void *out, size_t len, const void *in)
+{
+  uint32 *output = out;
+  const unsigned char *input = in;
+  size_t i, j;
+
+  for (i = 0, j = 0; j < len; i++, j += 4)
+    output[i] = ((uint32)input[j]) | (((uint32)input[j+1]) << 8) |
+      (((uint32)input[j+2]) << 16) | (((uint32)input[j+3]) << 24);
+}
+#endif /* __BIG_ENDIAN__ */
+
+/* MD4 initialization. Begins an MD4 operation, writing a new context.
+ */
+void
+MD4Init(MD4_CTX *context)
+{
+  context->count[0] = 0;
+  context->count[1] = 0;
+
+  /* Load magic initialization constants.
+   */
+  context->state[0] = 0x67452301;
+  context->state[1] = 0xefcdab89;
+  context->state[2] = 0x98badcfe;
+  context->state[3] = 0x10325476;
+}
+
+/* MD4 block update operation. Continues an MD4 message-digest
+     operation, processing another message block, and updating the
+     context.
+ */
+void
+MD4Update(MD4_CTX *context, const unsigned char *input, size_t inputLen)
+{
+  unsigned int i, idx, partLen;
+
+  /* Compute number of bytes mod 64 */
+  idx = (unsigned int)((context->count[0] >> 3) & 0x3F);
+
+  /* Update number of bits */
+  if ( (context->count[0] += ((uint32)inputLen << 3)) /* lower part of count */
+       < ((uint32)inputLen << 3) )
+    context->count[1]++; /* low part of count overflowed */
+
+  context->count[1] += ((uint32)inputLen >> 29); /* update high part of count */
+
+  partLen = 64 - idx;
+  /* Transform as many times as possible.  */
+  if (inputLen >= partLen) {
+    byte_copy
+      ((POINTER)&context->buffer[idx], partLen, input);
+    MD4Transform(context->state, context->buffer);
+
+    for (i = partLen; i + 63 < inputLen; i += 64)
+      MD4Transform(context->state, &input[i]);
+
+    idx = 0;
+  }
+  else
+    i = 0;
+
+  /* Buffer remaining input */
+  byte_copy
+    ((POINTER)&context->buffer[idx], inputLen-i, &input[i]);
+}
+
+/* MD4 finalization. Ends an MD4 message-digest operation, writing the
+     the message digest and zeroizing the context.
+ */
+void
+MD4Final(unsigned char digest[MD4_LEN], MD4_CTX *context)
+{
+  unsigned char bits[8];
+  unsigned int idx, padLen;
+  uint32 hi, lo;
+
+  /* Save number of bits */
+  hi = context->count[1];
+  lo = context->count[0];
+  Encode (bits, 4, &lo);
+  Encode (bits + 4, 4, &hi);
+
+  /* Pad out to 56 mod 64.
+   */
+  idx = (unsigned int)((context->count[0] >> 3) & 0x3f);
+  padLen = (idx < 56) ? (56 - idx) : (120 - idx);
+  MD4Update (context, PADDING, padLen);
+
+  /* Append length (before padding) */
+  MD4Update (context, bits, 8);
+
+  if (digest != (unsigned char *)0) {
+    /* Store state in digest */
+    Encode (digest, 16, context->state);
+
+    /* Zeroize sensitive information.
+     */
+	byte_zero((POINTER) context, sizeof (*context));
+  }
+}
+
+/* MD4 basic transformation. Transforms state based on block.
+ */
+static void
+MD4Transform(uint32 state[4], const unsigned char block[64])
+{
+  uint32 a = state[0], b = state[1], c = state[2], d = state[3], x[16];
+
+  Decode (x, 64, block);
+
+  /* Round 1 */
+  FF (a, b, c, d, x[ 0], S11); /* 1 */
+  FF (d, a, b, c, x[ 1], S12); /* 2 */
+  FF (c, d, a, b, x[ 2], S13); /* 3 */
+  FF (b, c, d, a, x[ 3], S14); /* 4 */
+  FF (a, b, c, d, x[ 4], S11); /* 5 */
+  FF (d, a, b, c, x[ 5], S12); /* 6 */
+  FF (c, d, a, b, x[ 6], S13); /* 7 */
+  FF (b, c, d, a, x[ 7], S14); /* 8 */
+  FF (a, b, c, d, x[ 8], S11); /* 9 */
+  FF (d, a, b, c, x[ 9], S12); /* 10 */
+  FF (c, d, a, b, x[10], S13); /* 11 */
+  FF (b, c, d, a, x[11], S14); /* 12 */
+  FF (a, b, c, d, x[12], S11); /* 13 */
+  FF (d, a, b, c, x[13], S12); /* 14 */
+  FF (c, d, a, b, x[14], S13); /* 15 */
+  FF (b, c, d, a, x[15], S14); /* 16 */
+
+  /* Round 2 */
+  GG (a, b, c, d, x[ 0], S21); /* 17 */
+  GG (d, a, b, c, x[ 4], S22); /* 18 */
+  GG (c, d, a, b, x[ 8], S23); /* 19 */
+  GG (b, c, d, a, x[12], S24); /* 20 */
+  GG (a, b, c, d, x[ 1], S21); /* 21 */
+  GG (d, a, b, c, x[ 5], S22); /* 22 */
+  GG (c, d, a, b, x[ 9], S23); /* 23 */
+  GG (b, c, d, a, x[13], S24); /* 24 */
+  GG (a, b, c, d, x[ 2], S21); /* 25 */
+  GG (d, a, b, c, x[ 6], S22); /* 26 */
+  GG (c, d, a, b, x[10], S23); /* 27 */
+  GG (b, c, d, a, x[14], S24); /* 28 */
+  GG (a, b, c, d, x[ 3], S21); /* 29 */
+  GG (d, a, b, c, x[ 7], S22); /* 30 */
+  GG (c, d, a, b, x[11], S23); /* 31 */
+  GG (b, c, d, a, x[15], S24); /* 32 */
+
+  /* Round 3 */
+  HH (a, b, c, d, x[ 0], S31); /* 33 */
+  HH (d, a, b, c, x[ 8], S32); /* 34 */
+  HH (c, d, a, b, x[ 4], S33); /* 35 */
+  HH (b, c, d, a, x[12], S34); /* 36 */
+  HH (a, b, c, d, x[ 2], S31); /* 37 */
+  HH (d, a, b, c, x[10], S32); /* 38 */
+  HH (c, d, a, b, x[ 6], S33); /* 39 */
+  HH (b, c, d, a, x[14], S34); /* 40 */
+  HH (a, b, c, d, x[ 1], S31); /* 41 */
+  HH (d, a, b, c, x[ 9], S32); /* 42 */
+  HH (c, d, a, b, x[ 5], S33); /* 43 */
+  HH (b, c, d, a, x[13], S34); /* 44 */
+  HH (a, b, c, d, x[ 3], S31); /* 45 */
+  HH (d, a, b, c, x[11], S32); /* 46 */
+  HH (c, d, a, b, x[ 7], S33); /* 47 */
+  HH (b, c, d, a, x[15], S34); /* 48 */
+
+  state[0] += a;
+  state[1] += b;
+  state[2] += c;
+  state[3] += d;
+
+  /* Zeroize sensitive information.
+   */
+  byte_zero((POINTER) x, sizeof (x));
+}
+
diff -ruN qmail-1.03-orig/digest_md4.h qmail-1.03-ldap-20060201-orig/digest_md4.h
--- qmail-1.03-orig/digest_md4.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/digest_md4.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,45 @@
+/* digest_md4.h for QLDAP modified to use djb's stuff */
+
+/*        */
+/*  MD4   */
+/*        */
+
+/* Copyright (C) 1991-2, RSA Data Security, Inc. Created 1991. All
+   rights reserved.
+
+   License to copy and use this software is granted provided that it
+   is identified as the "RSA Data Security, Inc. MD4 Message-Digest
+   Algorithm" in all material mentioning or referencing this software
+   or this function.
+   License is also granted to make and use derivative works provided
+   that such works are identified as "derived from the RSA Data
+   Security, Inc. MD4 Message-Digest Algorithm" in all material
+   mentioning or referencing the derived work.
+
+   RSA Data Security, Inc. makes no representations concerning either
+   the merchantability of this software or the suitability of this
+   software for any particular purpose. It is provided "as is"
+   without express or implied warranty of any kind.
+
+   These notices must be retained in any copies of any part of this
+   documentation and/or software.                                   */
+
+#ifndef _MD4_H_
+#define _MD4_H_
+
+#include "uint32.h"
+
+/* MD4 context. */
+typedef struct MD4Context {
+    uint32 state[4];            /* state (ABCD) */
+    uint32 count[2];            /* number of bits, modulo 2^64 */
+    unsigned char buffer[64];   /* input buffer */
+} MD4_CTX;
+
+#define MD4_LEN 16
+
+void   MD4Init(MD4_CTX *);
+void   MD4Update(MD4_CTX *, const unsigned char *, size_t);
+void   MD4Final(unsigned char [MD4_LEN], MD4_CTX *);
+
+#endif /* _MD4_H_ */
